/* A Gui in gtk+ for MuSE - Multiple Streaming Engine
 * Copyright (C) 2002 nightolo <night@autistici.org>
 *
 * This source code is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Public License as published 
 * by the Free Software Foundation; either version 2 of the License,
 * or (at your option) any later version.
 *
 * This source code is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * Please refer to the GNU Public License for more details.
 *
 * You should have received a copy of the GNU Public License along with
 * this source code; if not, write to:
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <stdlib.h>
#include <gtk/gtk.h>
#include "../jutils.h"

#include "generic.h"
#include "gchan.h"
#include "gchan_utils.h"
#include <jmixer.h>
#include <config.h>

struct gchan *findch(unsigned int ind,unsigned int pos)
{
	GList *listrunner;
	struct gchan *p;
	
	listrunner=g_list_first(listachan);

	while(listrunner) {
		p=(struct gchan *) listrunner->data;
		if(p->idx == ind || p->pos == pos) {
			return p;
		}
		listrunner=g_list_next(listrunner);
	}

	warning("GTK_GUI::findch : chan[%u] in pos[%u] not found", ind, pos);
	return NULL;
}

bool deletech(unsigned int ind)
{
	struct gchan *p=NULL;
	GList *listrunner;
	bool exist=false;

	listrunner=g_list_first(listachan);
	while(listrunner) {
		p=(struct gchan *) listrunner->data;
		if(p->idx == ind) {
			exist=true;
			func("GTK_GUI::deletech : channel %u found",ind);
			break;
		}
		listrunner=g_list_next(listrunner);
	}
	
	if(!exist) {
	  warning("GTK_GUI::deletech : chan[%u] not found for deletion", ind);
	  return false;
	}
	
	mixer->delete_channel(p->idx-1);

	/* It leaves me free to enjoy myself with list */
	if(p->pos==0)
		gtk_widget_destroy(GTK_WIDGET(p->windock));
	else {
		gtk_widget_destroy(GTK_WIDGET(p->frami));
		maxpos-=1;
	}
	channum[p->idx]=0;
	numc--;
	listachan=g_list_remove_link(listachan,listrunner);
	listachan=g_list_remove(listachan, listrunner->data);
	return true;
}

unsigned int firstchanfree(unsigned int array[])
{
	unsigned int c=0;
	while(c <= MAX_CHANNELS && array[++c] != 0)		;
	if(c<=6) return c;
	else return 0;
}

