/* A Gui in gtk+ for MuSE - Multiple Streaming Engine
 * Copyright (C) 2002 nightolo <night@autistici.org>
 *
 * This source code is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Public License as published 
 * by the Free Software Foundation; either version 2 of the License,
 * or (at your option) any later version.
 *
 * This source code is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * Please refer to the GNU Public License for more details.
 *
 * You should have received a copy of the GNU Public License along with
 * this source code; if not, write to:
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <string.h>
#include <stdlib.h>
#include <gtk/gtk.h>


#include "generic.h"
#include "profile.h"
#include "profilegui.h"
#include "lamegui.h"

#include <jutils.h>
#include <jmixer.h>
#include <config.h>

GtkWidget *lame_new(GtkWidget *w)
{
	GtkWidget *verbox, *tabbola, *hbox, *giu;
	GtkWidget *tmplabel;
	GtkWidget *scaled;
	GtkWidget *ok;
	char *charbit=NULL; 
	struct lamedata *l;
	GList *listola=NULL; /* recycling */
	
	l=(struct lamedata *) malloc(sizeof(struct lamedata));
/*	
	wind=gtk_window_new(GTK_WINDOW_TOPLEVEL);
	l->windlame=wind;
	gtk_container_set_border_width(GTK_CONTAINER(wind), 10);
	gtk_window_set_title(GTK_WINDOW(wind), "Configure your encoder" );
	gtk_signal_connect(GTK_OBJECT(wind), "delete_event",
			(GtkSignalFunc)gtk_widget_destroy, NULL);
*/	
	verbox=gtk_vbox_new(FALSE, 10);
/*	gtk_container_add(GTK_CONTAINER(wind), verbox);*/
	
	tabbola=gtk_table_new(3, 4, FALSE);
	gtk_table_set_row_spacings(GTK_TABLE(tabbola), 10);
	gtk_table_set_col_spacings(GTK_TABLE(tabbola), 10);
	gtk_box_pack_start(GTK_BOX(verbox), tabbola, FALSE, FALSE, 0);
	
	tmplabel=gtk_label_new("bitrate");
	gtk_table_attach_defaults(GTK_TABLE(tabbola), tmplabel, 0, 1, 0, 1);
	l->bitrate=gtk_combo_new();
	
	listola=g_list_append(listola, (void *) "8"); 
	listola=g_list_append(listola, (void *) "16"); 
	listola=g_list_append(listola, (void *) "24"); 
	listola=g_list_append(listola, (void *) "32"); 
	listola=g_list_append(listola, (void *) "56"); 
	listola=g_list_append(listola, (void *) "64"); 
	listola=g_list_append(listola, (void *) "96"); 
	listola=g_list_append(listola, (void *) "128");
	gtk_combo_set_popdown_strings(GTK_COMBO(l->bitrate), listola);
	charbit=(char *) malloc(sizeof(guibitrate));
	sprintf(charbit, "%d", guibitrate);
	gtk_entry_set_text(GTK_ENTRY(GTK_COMBO(l->bitrate)->entry), charbit);
	gtk_entry_set_editable(GTK_ENTRY(GTK_COMBO(l->bitrate)->entry), FALSE);
	g_list_free(listola);
	listola=NULL;

	gtk_widget_set_usize(l->bitrate, 70, 22); 
	gtk_table_attach_defaults(GTK_TABLE(tabbola), l->bitrate, 1, 2, 0, 1);

	tmplabel=gtk_label_new("frequency filtering");
	gtk_table_attach_defaults(GTK_TABLE(tabbola), tmplabel, 2, 3, 0, 1);
	l->freqfil=gtk_combo_new();
	
	listola=g_list_append(listola, (void *) "auto");
	listola=g_list_append(listola, (void *) "none");
	listola=g_list_append(listola, (void *) "manual");
	gtk_combo_set_popdown_strings(GTK_COMBO(l->freqfil), listola);
	g_list_free(listola);
	listola=NULL;
	gtk_signal_connect(GTK_OBJECT(GTK_COMBO(l->freqfil)->entry), "changed",
			(GtkSignalFunc) gcb_set_pass, l);
	gtk_widget_set_usize(l->freqfil, 70, 22);
	gtk_entry_set_editable(GTK_ENTRY(GTK_COMBO(l->freqfil)->entry), FALSE);
	gtk_table_attach_defaults(GTK_TABLE(tabbola), l->freqfil, 3, 4, 0, 1);

	
	tmplabel=gtk_label_new("frequency");
	gtk_table_attach_defaults(GTK_TABLE(tabbola), tmplabel, 0, 1, 1, 2);
	l->freq=gtk_combo_new();
	listola=g_list_append(listola, (void *) "auto");
	listola=g_list_append(listola, (void *) "11000");
	listola=g_list_append(listola, (void *) "16000");
	listola=g_list_append(listola, (void *) "22050");
	listola=g_list_append(listola, (void *) "44100");
	gtk_combo_set_popdown_strings(GTK_COMBO(l->freq), listola);
	g_list_free(listola);
	listola=NULL;
	gtk_widget_set_usize(l->freq, 70, 22);
	gtk_entry_set_editable(GTK_ENTRY(GTK_COMBO(l->freq)->entry), FALSE);
	gtk_table_attach_defaults(GTK_TABLE(tabbola), l->freq, 1, 2, 1, 2);

	tmplabel=gtk_label_new("lowpass Hz");
	gtk_table_attach_defaults(GTK_TABLE(tabbola), tmplabel, 2, 3, 1, 2);
	l->lowps=gtk_entry_new();
	gtk_entry_set_editable(GTK_ENTRY(l->lowps), FALSE);
	gtk_entry_set_text(GTK_ENTRY(l->lowps), "0");
	gtk_widget_set_usize(l->lowps, 70, 22);
	gtk_table_attach_defaults(GTK_TABLE(tabbola), l->lowps, 3, 4, 1, 2);

	tmplabel=gtk_label_new("channels");
	gtk_table_attach_defaults(GTK_TABLE(tabbola), tmplabel, 0, 1, 2, 3);
	l->chan=gtk_combo_new();
	listola=g_list_append(listola, (void *) "mono       3");
	listola=g_list_append(listola, (void *) "stereo     0");
	listola=g_list_append(listola, (void *) "jstereo    1");
	listola=g_list_append(listola, (void *) "dual chan  2");
	gtk_combo_set_popdown_strings(GTK_COMBO(l->chan), listola);
	gtk_combo_set_use_arrows_always(GTK_COMBO(l->chan), FALSE);
	gtk_widget_set_usize(l->chan, 80, 22);
	gtk_entry_set_editable(GTK_ENTRY(GTK_COMBO(l->chan)->entry), FALSE);
	gtk_table_attach_defaults(GTK_TABLE(tabbola), l->chan, 1, 2, 2, 3);
	g_list_free(listola);
	listola=NULL;
		
	tmplabel=gtk_label_new("highpass Hz");
	gtk_table_attach_defaults(GTK_TABLE(tabbola), tmplabel, 2, 3, 2, 3);
	l->highps=gtk_entry_new();
	gtk_entry_set_editable(GTK_ENTRY(l->highps), FALSE);
	gtk_entry_set_text(GTK_ENTRY(l->highps), "0");
	gtk_widget_set_usize(l->highps, 70, 22);
	gtk_table_attach_defaults(GTK_TABLE(tabbola), l->highps, 3, 4, 2, 3);
	
	hbox=gtk_hbox_new(FALSE, 4);
	gtk_box_pack_start(GTK_BOX(verbox), hbox, FALSE, FALSE, 0);

	tmplabel=gtk_label_new("Quality (1=best)");
	gtk_box_pack_start(GTK_BOX(hbox), tmplabel, FALSE, FALSE, 0);
	l->adj1=gtk_adjustment_new(0.0, 1.0, 9.0, 1.0, 1.0, 0.0);
	gtk_adjustment_set_value(GTK_ADJUSTMENT(l->adj1), 4.0);
	scaled=gtk_hscale_new(GTK_ADJUSTMENT(l->adj1));
	gtk_range_set_update_policy(GTK_RANGE(scaled), GTK_UPDATE_CONTINUOUS);
	gtk_scale_set_digits(GTK_SCALE(scaled), 0);
	gtk_scale_set_value_pos(GTK_SCALE(scaled), GTK_POS_LEFT);
	gtk_scale_set_draw_value(GTK_SCALE(scaled), TRUE);
	gtk_widget_set_usize(scaled, 100, 30);
	gtk_box_pack_start(GTK_BOX(hbox), scaled, FALSE, FALSE, 0);

	giu=gtk_hbox_new(TRUE, 0);
	gtk_box_pack_start(GTK_BOX(verbox), giu, FALSE, FALSE, 0);
	
	tmplabel=gtk_button_new_with_label("Browse Profile");
	gtk_object_set_data(GTK_OBJECT(tmplabel), "type", (void *)"lame");
	gtk_signal_connect(GTK_OBJECT(tmplabel), "clicked",
			(GtkSignalFunc) profile_new, l);
	gtk_box_pack_start(GTK_BOX(giu), tmplabel, TRUE, TRUE, 0);

	tmplabel=gtk_button_new_with_label("Save Profile");
	gtk_object_set_data(GTK_OBJECT(tmplabel), "type", (void *)"lame");
	gtk_signal_connect(GTK_OBJECT(tmplabel), "clicked",
			(GtkSignalFunc) profile_save, l);
	gtk_box_pack_start(GTK_BOX(giu), tmplabel, TRUE, TRUE, 0);
	
	ok=gtk_button_new_with_label("Apply");
	gtk_signal_connect(GTK_OBJECT(ok), "clicked", 
			(GtkSignalFunc)gcb_set_lame, l);
	gtk_box_pack_start(GTK_BOX(giu), ok, TRUE, TRUE, 0);
	
	/* set saved value */
	/* m'arcummanne i free su tutti gli alloc ;) */
	free(charbit);
	
	if(lametmp->status && lametmp->bps) 
		lame_put(l);
	
	return verbox;
}

void lame_put(struct lamedata *l)
{
	gtk_entry_set_text(GTK_ENTRY(GTK_COMBO(l->bitrate)->entry),
			lametmp->bps);
	gtk_entry_set_text(GTK_ENTRY(GTK_COMBO(l->freq)->entry),
			lametmp->fr);
	gtk_entry_set_text(GTK_ENTRY(GTK_COMBO(l->chan)->entry),
			lametmp->mod);
	gtk_entry_set_text(GTK_ENTRY(GTK_COMBO(l->freqfil)->entry),
			lametmp->freqfil);
	gtk_entry_set_text(GTK_ENTRY(l->lowps), lametmp->lps);
	gtk_entry_set_text(GTK_ENTRY(l->highps), lametmp->hps);
	gtk_adjustment_set_value(GTK_ADJUSTMENT(l->adj1), lametmp->quality);
}

void lame_get(struct lamedata *l)
{
	char *tmp;

	if(!l)
		return;

	func("lame_get(%p)", l);
	tmp=gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(l->bitrate)->entry));
	lametmp->bps=strdup(tmp);
	guibitrate=atoi(lametmp->bps);
	tmp=strdup(gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(l->freq)->entry)));
	lametmp->fr=strdup(tmp);
	if(!(strcmp(lametmp->fr,"auto")))
		lametmp->frequency=0;
	else
		lametmp->frequency=atoi(lametmp->fr);

	tmp=gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(l->chan)->entry));
	lametmp->mod=strdup(tmp);
	lametmp->mode=atoi(&lametmp->mod[strlen(lametmp->mod)-1]);
	lametmp->quality=(int)GTK_ADJUSTMENT(l->adj1)->value;

	lametmp->lps=strdup(gtk_entry_get_text(GTK_ENTRY(l->lowps)));
	lametmp->hps=strdup(gtk_entry_get_text(GTK_ENTRY(l->highps)));

	tmp=gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(l->freqfil)->entry));
	lametmp->freqfil=strdup(tmp);

	lametmp->status=true;

}

void gcb_set_pass(GtkWidget *w, struct lamedata *l)
{
	char *tmp;
	
	tmp=gtk_entry_get_text(GTK_ENTRY(w));

	if(!(strcmp(tmp, "auto"))) {
		gtk_entry_set_editable(GTK_ENTRY(l->lowps), FALSE);
		gtk_entry_set_editable(GTK_ENTRY(l->highps), FALSE);
		gtk_entry_set_text(GTK_ENTRY(l->lowps), "0");
		gtk_entry_set_text(GTK_ENTRY(l->highps), "0");
		return;
	}
	if(!(strcmp(tmp, "none"))) {
		gtk_entry_set_editable(GTK_ENTRY(l->lowps), FALSE);
		gtk_entry_set_editable(GTK_ENTRY(l->highps), FALSE);
		gtk_entry_set_text(GTK_ENTRY(l->lowps), "-1");
		gtk_entry_set_text(GTK_ENTRY(l->highps), "-1");
		return;
	}	
	gtk_entry_set_editable(GTK_ENTRY(l->lowps), TRUE);
	gtk_entry_set_editable(GTK_ENTRY(l->highps), TRUE);

}

void gcb_set_lame(GtkWidget *w, struct lamedata *l)
{
	int lowpass, highpass;

	//	profile_free_lame(lametmp);
	profile_init_lame(&lametmp);
	
	lame_get(l);
	
	lowpass=atoi(lametmp->lps);
	highpass=atoi(lametmp->hps);
	
	func("GTK_GUI:: gcb_set_lame :"
		"frequency[%d] mode[%d] quality[%d] bitrate[%d] lowpass[%d], highpass[%d]",
		lametmp->frequency, lametmp->mode, lametmp->quality, guibitrate, lowpass,
		highpass);
	if(mixer->icecastout) {
		mixer->stop_icecast();
		mixer->set_lame(guibitrate, lametmp->frequency, lametmp->mode,
			lametmp->quality, highpass, lowpass);
		mixer->set_icecast(icetmp->ip, icetmp->nport, icetmp->pass, 
						icetmp->mnt, guibitrate, icetmp->name,
						icetmp->url, icetmp->desc, icetmp->logtype);
	}
	else
		mixer->set_lame(guibitrate, lametmp->frequency, lametmp->mode,
			lametmp->quality, highpass, lowpass);

	//	profile_put_lame("last", lametmp);
	gtk_notebook_set_page(GTK_NOTEBOOK(nbook), 0);
	
}

void gcb_lame_get(GtkWidget *w, gint row, gint column, GdkEventButton *s,
		struct lamedata *l)
{
	bool res=false;
	gchar *str=NULL;
	
	l->riga=row;
	
	func("gcb_lame_get(%p, %d, %d, %p)", w, row, column, s);
	gtk_clist_get_text(GTK_CLIST(w), row, column, &str);
	func("gcb_lame_get:: selected %s profile", str);
	act("gcb_lame_get:: going to config for %s", str);

	res=profile_get_lame(str, lametmp);
	if(!res) {
		error("gcb_lame_get:: we got an error in profile_get_lame");
		return;
	}

}

void gcb_lame_put(GtkWidget *w, struct lamedata *l)
{
	lame_put(l);
}

void gcb_lame_save(GtkWidget *w, GtkWidget *e)
{
	char *profile=NULL;

	profile=gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(e)->entry));
	
	if(profile[0] == ' ') {
		warning("gcb_lame_save:: you should insert a filename");
		return;
	}
	profile_put_lame(profile, lametmp);
	gtk_widget_destroy(GTK_WIDGET(gtk_object_get_data(GTK_OBJECT(w), 
					"window")));
}

void gcb_lame_rem(GtkWidget *w, struct lamedata *l)
{
	char profile[100];
	char profdef[100];
	char *pd;
	
	func("gcb_lame_rem(%p, %p)", w, l);
	if(!l || !lametmp->profile) {
		warning("no profile selected");
		return;
	}

	func("gcb_lame_rem:: removing profile %s", lametmp->profile);
	snprintf(profile, sizeof(profile), "[lame=%s]", lametmp->profile);
	
	/* FIXME: return value here and in gcb_ice_rem */
	profile_remove(profile);
	pd=profile_get_default("lame");
	
	if((pd) && (strstr(profile_get_default("lame"), profile))) {
		snprintf(profdef, sizeof(profdef), "lamedefault=%s", profile);
		profile_remove(profdef);
	}

	
	if(l->riga != -1) {
		gtk_clist_remove(GTK_CLIST(l->lista), l->riga);
		l->riga=-1;
	}
	else
		warning("gcb_lame_rem:: I'm sorry, you have to select a profile before");
	
}

void gcb_lame_default(GtkWidget *w, struct lamedata *l)
{
	char *text=NULL;

	if(l->riga==-1)
		return;

	if(GTK_TOGGLE_BUTTON(w)->active) {
		gtk_clist_get_text(GTK_CLIST(l->lista), l->riga, 0, &text);
		profile_put_default("lame", text);
	}

}

