/* A Gui in gtk+ for MuSE - Multiple Streaming Engine
 * Copyright (C) 2002 nightolo <night@autistici.org>
 *
 * This source code is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Public License as published 
 * by the Free Software Foundation; either version 2 of the License,
 * or (at your option) any later version.
 *
 * This source code is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * Please refer to the GNU Public License for more details.
 *
 * You should have received a copy of the GNU Public License along with
 * this source code; if not, write to:
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <stdlib.h>
#include <gtk/gtk.h>


#include "generic.h"
#include "gchan.h"
#include "gchan_utils.h"
#include "main.h"

#include <jutils.h>
#include <jmixer.h>
#include <config.h>

void createtab(void)
{
	maintab=gtk_table_new(3, 2, FALSE);
	gtk_table_set_row_spacings(GTK_TABLE(maintab), 5);
	gtk_table_set_col_spacings(GTK_TABLE(maintab), 5);
	gtk_container_add(GTK_CONTAINER(vbox), maintab);
}

void putstatusbar(void)
{
	statusbar=gtk_statusbar_new();
	contextid=gtk_statusbar_get_context_id(GTK_STATUSBAR(statusbar),
			"La status bar");
	gtk_statusbar_push(GTK_STATUSBAR(statusbar), contextid, 
			"status bar: ogg sborvis");
	gtk_box_pack_start(GTK_BOX(vbox), statusbar, TRUE, TRUE, 0);
	
}

void gcb_set_speakout(GtkWidget *w)
{
	bool res=false;
	
	if(GTK_TOGGLE_BUTTON(w)->active)
		res=mixer->set_lineout(true);
	else
		mixer->set_lineout(false);

	if(!res)
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(w), FALSE);
}

void gcb_set_linein(GtkWidget *w)
{
  bool res=false;
  
  if(GTK_TOGGLE_BUTTON(w)->active) res=mixer->set_live(true);
  else mixer->set_live(false);
  
  if(!res) gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(w), FALSE);
}

void gcb_set_talk(GtkWidget *w)
{
	unsigned int i;
	float voltmp[numc];
	struct gchan *c;
	
	if(GTK_TOGGLE_BUTTON(w)->active) {
		for(i=0; i < numc; i++) {
			c=findch(NOIDX, i+1);
			storevol[i]= GTK_ADJUSTMENT(c->adjvol)->value;
			if(storevol[i] < TALK_VOLUME)
				voltmp[i]=0.0;
			else
				voltmp[i]= TALK_VOLUME;
			gtk_adjustment_set_value(GTK_ADJUSTMENT(c->adjvol), voltmp[i]);
		}
		mixer->set_all_volumes(&voltmp[0]);
		
			
	}
	else {
		for(i=0; i < numc; i++) {
			c=findch(NOIDX,i+1);
			gtk_adjustment_set_value(GTK_ADJUSTMENT(c->adjvol), storevol[i]);
		}
		mixer->set_all_volumes(&storevol[0]);
	}
	
}
	
void gcb_exit(GtkWidget *w, GdkEvent *s)
{
	state=false;
}

