/* A Gui in gtk+ for MuSE - Multiple Streaming Engine
 * Copyright (C) 2002 nightolo <night@autistici.org>
 *
 * This source code is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Public License as published 
 * by the Free Software Foundation; either version 2 of the License,
 * or (at your option) any later version.
 *
 * This source code is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * Please refer to the GNU Public License for more details.
 *
 * You should have received a copy of the GNU Public License along with
 * this source code; if not, write to:
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <stdlib.h>
#include <gtk/gtk.h>
#include "../generic.h"
#include "../config.h"
#include "../jutils.h"
#include "generic.h"
#include "gchan.h"
#include "gchan_utils.h"
#include "packing.h"

bool packchan(struct gchan *chan, unsigned int pos)
{
  if(pos > MAX_CHANNELS) {
    error("GTK_GUI::packchan : Sorry I'm not able to pack chan %u \n",pos);
    return FALSE;
  }

	switch(pos) {
		case 1: gtk_table_attach_defaults(GTK_TABLE(maintab), chan->frami,
						0, 1, 0, 1);
				break;
		case 2: gtk_table_attach_defaults(GTK_TABLE(maintab), chan->frami, 
						1, 2, 0, 1);
				break;
		case 3: gtk_table_attach_defaults(GTK_TABLE(maintab), chan->frami,
						0, 1, 1, 2);
				break;
		case 4: gtk_table_attach_defaults(GTK_TABLE(maintab), chan->frami,
						1, 2, 1, 2);
				break;
		case 5: gtk_table_attach_defaults(GTK_TABLE(maintab), chan->frami,
						0, 1, 2, 3);
				break;
		case 6: gtk_table_attach_defaults(GTK_TABLE(maintab), chan->frami,
						1, 2, 2, 3);
				break;
		default: g_print("nothing to do");
	}
	chan->pos=pos;
	gtk_widget_show_all(chan->frami);
	return TRUE;
}

bool repack(unsigned int pos)
{
	struct gchan *tmp;

	pos+=1;
	while(pos<=maxpos+1) {
	  func("GTK_GUI::repack : while(%u <= %u)", pos, maxpos+1);
	  tmp=findch(NOIDX, pos);
	  func("GTK_GUI::repack : tmp=%p su tmp->idx=%u", tmp, tmp->idx);
	  if(tmp) {
	    func("GTK_GUI::repack : struct found");
			gtk_object_ref(GTK_OBJECT(tmp->frami));
			gtk_container_remove(GTK_CONTAINER(maintab), tmp->frami);
			packchan(tmp, pos-1);
			gtk_object_unref(GTK_OBJECT(tmp->frami));
			pos++;
		}
		else 
			return false;
	}
	return true;
}

