/* A Gui in gtk+ for MuSE - Multiple Streaming Engine
 * Copyright (C) 2002 nightolo <night@autistici.org>
 *
 * This source code is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Public License as published 
 * by the Free Software Foundation; either version 2 of the License,
 * or (at your option) any later version.
 *
 * This source code is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * Please refer to the GNU Public License for more details.
 *
 * You should have received a copy of the GNU Public License along with
 * this source code; if not, write to:
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/* config stuff */

#ifndef	PROFILE_H 
#define PROFILE_H

struct lamesave {
	char *bps, *fr, *mod, *freqfil; /* bitrate, frequency, 
									   mode, frequency filtering */ 
	char *lps, *hps;		 /* highpass, lowpass */
	int frequency, mode;
	char *profile;
	int quality;
	bool status;
};

struct icesave {
	char *ip, *port, *mnt, /* bps */ *pass, *name, *url, *desc, *login;
	char *profile;
	int nport, logtype;
	bool status;
};

void profile_init(void);
/* FIXME: return value */

/* @type= "lame" or "icecast" profile  @pnam= array of pointers (max
 * 10) where I'm storing profile name (only name) */
void profile_get_profile(char *type, char **pnam);
/* free strdup */
void profile_free_pnam(char **pnam);

/* @patter= a pattern to be removed (for lame pattern looks like
 * "[lame=profilename]", profile_remove delete all 'til it'll find a
 * newline */
void profile_remove(char *pattern);


char *profile_get_default(char *type);
/* put "type=what" in config file for default selection 
 * @what= profile name */
void profile_put_default(char *type, char *what);

/* all of these functions fill a struct lamesave with data found in
 * profile (if it found) */
bool profile_init_lame(struct lamesave **);
void profile_free_lame(struct lamesave *);
bool profile_get_lame(char *profile, struct lamesave *);
bool profile_put_lame(char *profile, struct lamesave *);

bool profile_init_ice(struct icesave **);
void profile_free_ice(struct icesave *);
bool profile_get_ice(char *profile, struct icesave *);
bool profile_put_ice(char *profile, struct icesave *);

#endif
