/* A Gui in gtk+ for MuSE - Multiple Streaming Engine
 * Copyright (C) 2002 nightolo <night@autistici.org>
 *
 * This source code is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Public License as published 
 * by the Free Software Foundation; either version 2 of the License,
 * or (at your option) any later version.
 *
 * This source code is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * Please refer to the GNU Public License for more details.
 *
 * You should have received a copy of the GNU Public License along with
 * this source code; if not, write to:
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <gtk/gtk.h>
#include "generic.h"
#include "pixmaps.h"
#include "main.h"
#include "gchan.h"
#include "icelame.h"
#include "about.h"
#include "utils.h"


GtkWidget *createbbox(GtkWidget *bbox)
{
	GtkWidget *ice, *clame, *addch, *help;
	
	ice=clame=addch=help=NULL;

	bbox=gtk_hbutton_box_new();
	gtk_button_box_set_child_size(GTK_BUTTON_BOX(bbox), 7, 10);
	gtk_hbutton_box_set_spacing_default(0);
	gtk_hbutton_box_set_layout_default(GTK_BUTTONBOX_START);
	
	ice=createpixmap(window, ice, stock_jump_to_xpm, "Let's stream!", FALSE);
	gtk_signal_connect(GTK_OBJECT(ice), "clicked", 
			(GtkSignalFunc)icelame, NULL);
	gtk_container_add(GTK_CONTAINER(bbox), ice);

/*	clame=createpixmap(window, clame, stock_book_blue_xpm, "Configure encoder",
			FALSE);
	gtk_signal_connect(GTK_OBJECT(clame), "clicked",
			(GtkSignalFunc)lame_new, NULL);
	gtk_container_add(GTK_CONTAINER(bbox), clame);*/
	
	addch=createpixmap(window, addch, stock_multiple_file_xpm, 
			"Add Channel", FALSE);
	gtk_signal_connect(GTK_OBJECT(addch), "clicked",
			(GtkSignalFunc)gcb_createch, NULL); /* I'm stupid */
	gtk_container_add(GTK_CONTAINER(bbox), addch);
		
	help=createpixmap(window, help, stock_help_xpm, "About", FALSE);
	gtk_signal_connect(GTK_OBJECT(help), "clicked",
			(GtkSignalFunc) aboutwin, NULL);
	gtk_container_add(GTK_CONTAINER(bbox), help);
	
	mic=createpixmap(window, mic, stock_mic_xpm, "Talk", TRUE);
	gtk_signal_connect(GTK_OBJECT(mic), "clicked",
			(GtkSignalFunc) gcb_set_talk, NULL);
	gtk_container_add(GTK_CONTAINER(bbox), mic);
	
	linein=createpixmap(window, linein, stock_line_in_xpm, "Line In", TRUE);
	gtk_signal_connect(GTK_OBJECT(linein), "clicked",
			(GtkSignalFunc) gcb_set_linein, NULL);
	gtk_container_add(GTK_CONTAINER(bbox), linein);

	speakout=createpixmap(window, speakout, stock_volume_xpm, "Speaker", TRUE);
	gtk_signal_connect(GTK_OBJECT(speakout), "clicked",
			(GtkSignalFunc) gcb_set_speakout, NULL);
	gtk_container_add(GTK_CONTAINER(bbox), speakout);
	
	return bbox;

}

GtkWidget *createpixmap(GtkWidget *w, GtkWidget *but, 
		gchar **pippo, gchar *tip, bool istoggled)
{
	/* create and return button with pixmap */

	GtkWidget *pixmapwid;
	GtkTooltips *tooltip;
	GdkPixmap *pixmap;
	GdkBitmap *mask;
	GtkStyle *style;

	style=gtk_widget_get_style(w);
	gtk_widget_realize(w);
	pixmap=gdk_pixmap_create_from_xpm_d(w->window, &mask, 
			&style->bg[GTK_STATE_NORMAL], pippo);
	pixmapwid=gtk_pixmap_new(pixmap, mask);
	if(!istoggled)
		but=gtk_button_new();
	else
		but=gtk_toggle_button_new();

	gtk_container_add(GTK_CONTAINER(but), pixmapwid);
	tooltip=gtk_tooltips_new();
	gtk_tooltips_set_tip(GTK_TOOLTIPS(tooltip), but, tip, NULL);
	return but;
	
}
